indexing
	description	: "Objects that ..."

	rcsfile		: "$RCSfile: erl_class.e,v $"
	revision	: "$Revision: 1.9 $"

	author		: "$Author: fluribe $"
	date		: "$Date: 2004/06/29 19:41:29 $"

deferred class
	ERL_CLASS

feature -- Access

	name: STRING is
			-- Name of this class
		deferred
		end

	formal_generics: LIST [ERL_GENERIC] is
			-- Formal generic parameter of this class
		deferred
		end

feature -- Status report

	is_generic: BOOLEAN is
			-- Is this class a generic class?
		deferred
		end

	conform_generic_constraints (a_actuals: LIST [ERL_TYPE]): BOOLEAN is
			-- Does actuals `a_actuals' conform to generic constraints of
			-- this class?
		deferred
		end

	exists_type_with_actuals (a_actuals: LIST [ERL_TYPE]): BOOLEAN is
			-- Does type derived from this class with actual generic parameters
			-- `a_actuals' exist?
		deferred
		end

feature -- Basic operation

	type_with_actuals (a_actuals: LIST [ERL_TYPE]): ERL_TYPE is
			-- Type derived from this class with actual generic parameters
			-- `a_actuals'.
		require
			a_actuals_conform_constraints: conform_generic_constraints (a_actuals)
		deferred
		end

invariant
	name_not_empty: name /= Void and then
					not name.is_empty
	formal_generics: formal_generics /= Void
					 and
					 is_generic implies not formal_generics.is_empty

end -- class ERL_CLASS
