indexing
	description	: "Objects that ..."

	rcsfile		: "$RCSfile: erl_function.e,v $"
	revision	: "$Revision: 1.11 $"

	author		: "$Author: fluribe $"
	date		: "$Date: 2004/07/13 17:20:50 $"

deferred class
	ERL_FUNCTION

inherit
	ERL_ROUTINE
		rename
			routine as function
		redefine
			parents,
			effective_parent,
			function,
			call
		end

	ERL_QUERY
		rename
			can_postcondition_be_checked as was_call_made
		redefine
			parents,
			effective_parent
		end

feature -- Access

	parents: LIST [ERL_FUNCTION] is
			-- Function in parent class if redefined
		deferred
		end

	effective_parent: ERL_FUNCTION is
			-- Effective function in one of the parent classes
			-- if inherited and redefined or renamed
		deferred
		end

	item: ANY is
			-- Result of the last call
		require else
			valid_operands_set: valid_operands (operands)
		do
			call
			Result := function.last_result
		end

	call is
		do
			Precursor
			last_result := function.last_result
		end

	last_result: ANY

feature {ERL_ROUTINE} -- Implementation

	routine: ROUTINE [ANY, TUPLE] is
		do
			Result := function
		end

feature {NONE} -- Implementation

	function: FUNCTION [ANY, TUPLE, ANY]
			-- Interface to the real function

end -- class ERL_FUNCTION
