indexing
	description	: "Objects that ..."

	rcsfile		: "$RCSfile: erl_universe.e,v $"
	revision	: "$Revision: 1.3 $"

	author		: "$Author: fluribe $"
	date		: "$Date: 2004/06/29 19:41:29 $"

deferred class
	ERL_UNIVERSE

inherit

	INTERNAL

feature -- Access

	types: LIST [ERL_TYPE] is
			-- All used types in the system
		deferred
		end

	type_by_name (a_name: STRING): ERL_TYPE is
			-- Search type by name `a_name'.
		local
			old_cursor: CURSOR
		do
			old_cursor := types.cursor
			from
				types.start
			until
				types.after or Result /= Void
			loop
				if types.item.name.is_equal (a_name) then
					Result := types.item
				end
				types.forth
			end
			types.go_to (old_cursor)
		end

	type_by_object (an_object: ANY): ERL_TYPE is
			-- Type for object `an_object'
		do
			if an_object = Void then
				Result := type_by_name ("NONE")
			else
				Result := type_by_name (type_name (an_object))
			end
		end

feature -- Basic operation

	class_for_name (a_name: STRING): ERL_CLASS is
			-- Class for name `a_name'
		require
			a_name_not_empty: a_name /= Void and then not a_name.is_empty
		do
			create {ERL_CLASS_IMP} Result.make (a_name, False)
		end

end -- class ERL_UNIVERSE
