indexing
	description	: "Objects that ..."

	rcsfile		: "$RCSfile: erl_class_imp.e,v $"
	revision	: "$Revision: 1.7 $"

	author		: "$Author: fluribe $"
	date		: "$Date: 2004/07/15 11:58:00 $"

class
	ERL_CLASS_IMP

inherit
	ERL_CLASS

	GERL_SHARED_UNIVERSE

create
	make

feature {NONE} -- Initialization

	make (a_name: STRING; generic: BOOLEAN) is
			-- Initialize `Current'.
		require
			a_name_not_empty: a_name /= Void and then
							  not a_name.is_empty
		do
			name := a_name
			is_generic := generic
		ensure
			name_set: name = a_name
			is_generic_set: is_generic = generic
		end

feature -- Access

	name: STRING
			-- See `{ERL_CLASS}.name' for more details.

	formal_generics: LIST [ERL_GENERIC] is
			-- See `{ERL_CLASS}.formal_generics' for more details.
		do
			create {LINKED_LIST [ERL_GENERIC]} Result.make
			if is_generic then
				Result.extend (create {ERL_GENERIC_IMP}.make)
			end
		end

feature -- Status report

	is_generic: BOOLEAN
			-- Is this class a generic class?

	conform_generic_constraints (a_actuals: LIST [ERL_TYPE]): BOOLEAN is
			-- Does actuals `a_actuals' conform to generic constraints of
			-- this class?
		local
			fg: LIST [ERL_GENERIC]
			c: LIST [ERL_CONSTRAINT]
		do
			--| FIXME delete next line, when formal generic are availabe
			Result := True
			fg := formal_generics
			if a_actuals.count = fg.count then
				Result := True
			end
		end

	exists_type_with_actuals (a_actuals: LIST [ERL_TYPE]): BOOLEAN is
			-- Does type derived from this class with actual generic parameters
			-- `a_actuals' exist?
		local
			ts: STRING
		do
			ts := type_string (a_actuals)
			-- Result := universe.exists_type_for_name (ts)
				check
					todo: False
				end
		end

feature -- Status setting

	set_generic_count (a_number: INTEGER) is
			-- Set `generic_count' to `a_number'.
		require
			a_number_positive: a_number > -1
		do
			generic_count := a_number
		ensure
			generic_count_set: generic_count = a_number
		end

feature -- Basic operation

	type_with_actuals (a_actuals: LIST [ERL_TYPE]): ERL_TYPE is
			-- See `{ERL_CLASS}.type_with_actuals' for more details.
		local
			ts: STRING
		do
			ts := type_string (a_actuals)
			-- create {ERL_TYPE_IMP} Result.make_for_name (ts)
		end

feature {NONE} -- Implementation

	type_string (a_actuals: LIST [ERL_TYPE]): STRING is
			-- Type string with actuals `a_actuals'
		do
			a_actuals.start
			Result := name + " [" + a_actuals.item.name
			from
				a_actuals.forth
			until
				a_actuals.after
			loop
				Result := Result + ", " + a_actuals.item.name
				a_actuals.forth
			end
			Result := Result + "]"
		end


	generic_count: INTEGER
			-- Number of generic parameter

end -- class ERL_CLASS_IMP
