indexing

	description	: "Objects that ..."
	author		: "$Author: fluribe $"
	date		: "$Date: 2004/07/13 17:20:50 $"

class
	ERL_FUNCTION_IMP

inherit
	ERL_FUNCTION
		undefine
			precondition
		select
			function
		end

	ERL_QUERY_IMP
		rename
			make as make_query_imp,
			can_postcondition_be_checked as was_call_made
		end

	ERL_ROUTINE_IMP
		rename
			make as make_routine_imp
		undefine
			call
		redefine
			was_call_made
		select
			make_routine_imp
		end

create
	make

feature {NONE} -- Initialize

	make (a_names: like names;
			a_type: like type;
			a_function: like function;
			a_formal_arguments: like formal_arguments;
			a_result_type: like result_type) is
			-- Initialize `Current'.
		require
			a_names_exists: a_names /= Void
			a_names_not_empty: not a_names.is_empty
			a_names_items_not_emtpy: names_not_empty (a_names)
			a_type_not_void: a_type /= Void
			a_function_not_void: a_function /= Void
			a_formal_arguments_not_void: a_formal_arguments /= Void
		do
			make_routine_imp (a_names, a_type)
			function := a_function
			formal_arguments := a_formal_arguments
			result_type := a_result_type
		ensure then
			names_set: names = a_names
			type_set: type = a_type
			function_set: function = a_function
			formal_arguments_set: formal_arguments = a_formal_arguments
			result_type_set: result_type = a_result_type
		end

feature -- Access

	result_type: ERL_TYPE

	parents: LIST [ERL_FUNCTION] is
			-- See `{ERL_FUNCTION}.parents' for more details.
		do
			--| FIXME compiler / runtime support needed.
			create {ARRAYED_LIST [ERL_FUNCTION]} Result.make (1)
		end

	effective_parent: ERL_FUNCTION is
			-- See `{ERL_FUNCTION}.effective_parent' for more details.
		do
			--| FIXME compiler / runtime support needed.
		end

feature -- Status setting

	set_function (a_function: FUNCTION [ANY, TUPLE, ANY]) is
			--
		do
			function := a_function
		end

end -- class ERL_FUNCTION_IMP
