indexing
	description	: "Objects that ..."

	rcsfile		: "$RCSfile: erl_routine_imp.e,v $"
	revision	: "$Revision: 1.7 $"

	author		: "$Author: fluribe $"
	date		: "$Date: 2004/07/13 17:20:50 $"

deferred class
	ERL_ROUTINE_IMP

inherit
	ERL_ROUTINE
		redefine
			precondition
		end

	ERL_FEATURE_IMP
		rename
			can_postcondition_be_checked as was_call_made
		redefine
			parents,
			effective_parent,
			was_call_made
		end

feature -- Access

	formal_arguments: LIST [ERL_ARGUMENT]

	parents: LIST [ERL_ROUTINE] is
			-- See `{ERL_ROUTINE}.parents' for more details.
		deferred
		end

	effective_parent: ERL_ROUTINE is
			-- See `{ERL_ROUTINE}.effective_parent' for more details.
		deferred
		end

	precondition (a_operands: TUPLE): BOOLEAN is
		do
			Result := precondition_function.item (a_operands)
		end

	set_precondition_function (a_function: like precondition_function) is
		require
			a_function_not_void: a_function /= Void
		do
			precondition_function := a_function
		ensure
			precondition_function_set: precondition_function = a_function
		end

	precondition_function: FUNCTION [ANY, TUPLE, BOOLEAN]

feature {ERL_ROUTINE} -- Implementation

	cache_old is
			-- See `{ERL_ROUTINE}.cache_old' for more details.
		do
			--| FIXME compiler / runtime support needed.
		end

feature {NONE} -- Implementation

	is_deferred_type (type_id: INTEGER): BOOLEAN is
			-- Is the type of `type_id' deferred?
		local
			o: ANY
			already: BOOLEAN
			internal: INTERNAL
		do
			if not already then
				create internal
				o := internal.new_instance_of (type_id)
				Result := False
			else
				Result := True
			end
		rescue
			already := True
			retry
		end

	new_reference_instance (a_name: STRING): ANY is
			-- New instance of type `a_name'
		local
			int: INTERNAL
			type_id: INTEGER
		do
			create int
			type_id := int.dynamic_type_from_string (a_name)
			Result := int.new_instance_of (type_id)
		end

	internal_formal_arguments: FIXED_LIST [ERL_ARGUMENT]
			-- Cached formal arguments

	Dummy_arg_name: STRING is "arg_"
			-- Dummy argument name
			--| FIXME compiler / runtime support needed to obtain
			--| correct argument name.

end -- class ERL_ROUTINE_IMP
